'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.socketDisconnect = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _socket = require('socket.io-client');

var _socket2 = _interopRequireDefault(_socket);

var _giu = require('giu');

var _appContents = require('./015-appContents');

var _appContents2 = _interopRequireDefault(_appContents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/* eslint-env browser */


var socket = _socket2.default.connect();
var socketDisconnect = function socketDisconnect() {
  socket.close();
};

// ==========================================
// Component declarations
// ==========================================

// ==========================================
// Component
// ==========================================
var App = function (_React$Component) {
  _inherits(App, _React$Component);

  function App(props) {
    _classCallCheck(this, App);

    var _this = _possibleConstructorReturn(this, (App.__proto__ || Object.getPrototypeOf(App)).call(this, props));

    _this.state = {
      fetchedItemType: null,
      fetchedItem: null,
      fetchedItemPath: null,
      error: null,
      fRedirectToRoot: false
    };
    (0, _giu.bindAll)(_this, ['refetch']);
    return _this;
  }

  // unit testing


  _createClass(App, [{
    key: '_setState',
    value: function _setState(state) {
      this.setState(state);
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.fetchSidebarData(undefined, this.props);
      socket.on('REFRESH', this.refetch);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      socket.off('REFRESH', this.refetch);
    }
  }, {
    key: 'componentWillUpdate',
    value: function componentWillUpdate(nextProps) {
      this.fetchSidebarData(this.props, nextProps);
    }
  }, {
    key: 'fetchSidebarData',
    value: function fetchSidebarData(prevProps, nextProps) {
      var pathname = nextProps.pathname,
          pattern = nextProps.pattern,
          params = nextProps.params;

      if (prevProps != null && pathname === prevProps.pathname) return;
      if (pathname === '/') {
        this.fetchFolder('-');
      } else if (pattern.indexOf('/folder') === 0) {
        this.fetchFolder(params[0]);
      } else if (pattern.indexOf('/suite') === 0) {
        this.fetchSuite(params[0]);
      }
    }

    // ------------------------------------------

  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      return _react2.default.createElement(_appContents2.default, {
        fetchedItemType: this.state.fetchedItemType,
        fetchedItem: this.state.fetchedItem,
        fetchedItemPath: this.state.fetchedItemPath,
        error: this.state.error,
        onRedirectToRoot: function onRedirectToRoot() {
          _this2.setState({ fRedirectToRoot: true });
        },
        fRedirectToRoot: this.state.fRedirectToRoot,
        query: this.props.location.query
      });
    }

    // ------------------------------------------

  }, {
    key: 'refetch',
    value: function refetch() {
      if (!this.state.fetchedItem) return;
      if (this.state.fetchedItemType === 'FOLDER') {
        this.fetchFolder(this.state.fetchedItemPath);
      } else {
        this.fetchSuite(this.state.fetchedItemPath);
      }
    }
  }, {
    key: 'fetchFolder',
    value: function fetchFolder(folderPath) {
      var _this3 = this;

      fetch('/api/folder', {
        method: 'POST',
        headers: { 'content-type': 'application/json' },
        body: JSON.stringify({ folderPath: folderPath })
      }).then(function (res) {
        return res.json();
      }).then(function (folder) {
        _this3.setState({
          fetchedItemType: 'FOLDER',
          fetchedItem: folder,
          fetchedItemPath: folderPath
        });
      }).catch(function () {
        _this3.setState({
          error: 'Could not find ' + folderPath
        });
      });
    }
  }, {
    key: 'fetchSuite',
    value: function fetchSuite(filePath) {
      var _this4 = this;

      fetch('/api/suite', {
        method: 'POST',
        headers: { 'content-type': 'application/json' },
        body: JSON.stringify({ filePath: filePath })
      }).then(function (res) {
        return res.json();
      }).then(function (suite) {
        _this4.setState({
          fetchedItemType: 'SUITE',
          fetchedItem: suite,
          fetchedItemPath: filePath
        });
      }).catch(function () {
        _this4.setState({
          error: 'Could not find ' + filePath
        });
      });
    }
  }]);

  return App;
}(_react2.default.Component);

// ==========================================
// Public API
// ==========================================


exports.default = App;
exports.socketDisconnect = socketDisconnect;