'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouter = require('react-router');

var _giu = require('giu');

var _sidebar = require('./110-sidebar');

var _sidebar2 = _interopRequireDefault(_sidebar);

var _sidebarItem = require('./115-sidebarItem');

var _sidebarItem2 = _interopRequireDefault(_sidebarItem);

var _preview = require('./120-preview');

var _preview2 = _interopRequireDefault(_preview);

var _largeMessage = require('./200-largeMessage');

var _largeMessage2 = _interopRequireDefault(_largeMessage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/* eslint-env browser */


require('./010-app.sass');

// const breakAtSlashes = (str) => str.replace(/\//g, '/\u200B');
var breakAtDots = function breakAtDots(str) {
  return str.replace(/\./g, '.\u200B');
};
var lastSegment = function lastSegment(path) {
  if (!path) return '';
  var segments = path.split('/');
  return segments[segments.length - 1];
};
var snapshotName = function snapshotName(id) {
  var segments = id.split(' ');
  return segments.slice(0, segments.length - 1).join(' ');
};

var _escape = function _escape(str) {
  return encodeURIComponent(str);
};

// ==========================================
// Component declarations
// ==========================================

// ==========================================
// Component
// ==========================================
var AppContents = function (_React$PureComponent) {
  _inherits(AppContents, _React$PureComponent);

  function AppContents(props) {
    _classCallCheck(this, AppContents);

    var _this = _possibleConstructorReturn(this, (AppContents.__proto__ || Object.getPrototypeOf(AppContents)).call(this, props));

    _this.toggleRaw = function () {
      _this.setState({ fRaw: !_this.state.fRaw });
    };

    _this.state = {
      fRaw: false
    };
    return _this;
  }

  _createClass(AppContents, [{
    key: 'render',
    value: function render() {
      if (this.props.fRedirectToRoot) {
        return _react2.default.createElement(_reactRouter.Redirect, { to: '/' });
      }
      if (this.props.error) {
        return _react2.default.createElement(
          _largeMessage2.default,
          null,
          _react2.default.createElement(_giu.Icon, { icon: 'warning', disabled: true }),
          ' ',
          _react2.default.createElement(
            'b',
            null,
            'An error occurred:'
          ),
          _react2.default.createElement('br', null),
          this.props.error,
          _react2.default.createElement('br', null),
          _react2.default.createElement(
            _giu.Button,
            {
              onClick: this.props.onRedirectToRoot
            },
            _react2.default.createElement(_giu.Icon, { icon: 'home', disabled: true }),
            ' ',
            'Home'
          )
        );
      }
      if (!this.props.fetchedItem) {
        return _react2.default.createElement(
          _largeMessage2.default,
          null,
          _react2.default.createElement(_giu.Spinner, null),
          '\xA0Loading\u2026'
        );
      }
      return _react2.default.createElement(
        'div',
        { style: style.outer },
        _react2.default.createElement(_giu.Floats, null),
        this.renderSidebar(),
        this.renderPreview()
      );
    }
  }, {
    key: 'renderSidebar',
    value: function renderSidebar() {
      var fFolder = this.props.fetchedItemType === 'FOLDER';
      var fetchedItemPath = this.props.fetchedItemPath;

      var _ref = fFolder ? this.renderFolder() : this.renderSuite(),
          contents = _ref.contents,
          linkBack = _ref.linkBack;

      var title = void 0;
      if (fFolder) {
        var folder = this.props.fetchedItem;
        title = folder.parentFolderPath != null ? _react2.default.createElement(
          'span',
          null,
          _react2.default.createElement(_giu.Icon, { icon: 'folder-open-o', style: style.titleBarIcon }),
          '\xA0',
          lastSegment(fetchedItemPath)
        ) : _react2.default.createElement(
          'span',
          null,
          _react2.default.createElement(_giu.Icon, { icon: 'home', style: style.titleBarIcon }),
          '\xA0Root'
        );
      } else {
        title = _react2.default.createElement(
          'span',
          null,
          _react2.default.createElement(_giu.Icon, { icon: 'file-o', style: style.titleBarIcon }),
          '\xA0',
          lastSegment(fetchedItemPath).split('.')[0]
        );
      }
      return _react2.default.createElement(
        _sidebar2.default,
        {
          title: title,
          subtitle: fetchedItemPath,
          linkBack: linkBack,
          fRaw: this.state.fRaw,
          toggleRaw: this.toggleRaw
        },
        contents
      );
    }
  }, {
    key: 'renderFolder',
    value: function renderFolder() {
      var folder = this.props.fetchedItem;
      var contents = [];
      folder.childrenFolderPaths.forEach(function (folderPath) {
        var id = 'folder_' + folderPath;
        var label = folderPath;
        var tmpIndex = label.indexOf(folder.folderPath + '/');
        if (tmpIndex >= 0) label = label.slice(folder.folderPath.length + 1);
        label = breakAtDots(label);
        contents.push(_react2.default.createElement(_sidebarItem2.default, {
          key: id,
          id: id,
          label: label,
          link: '/folder/' + _escape(folderPath),
          icon: 'folder-o',
          fSelected: false
        }));
      });
      folder.filePaths.forEach(function (filePath) {
        var id = 'suite_' + filePath;
        var label = filePath;
        var tmpIndex = label.indexOf(folder.folderPath + '/');
        if (tmpIndex >= 0) label = label.slice(folder.folderPath.length + 1);
        label = breakAtDots(label);
        contents.push(_react2.default.createElement(_sidebarItem2.default, {
          key: id,
          id: id,
          label: label,
          link: '/suite/' + _escape(filePath),
          icon: 'file-o',
          fSelected: false
        }));
      });
      var linkBack = folder.parentFolderPath != null ? '/folder/' + folder.parentFolderPath : null;
      return { contents: contents, linkBack: linkBack };
    }
  }, {
    key: 'renderSuite',
    value: function renderSuite() {
      var suite = this.props.fetchedItem;
      var fetchedItemPath = this.props.fetchedItemPath;
      var query = this.props.query;

      var contents = [];
      var groups = {};
      Object.keys(suite).forEach(function (id) {
        if (id === '__folderPath') return;
        var name = snapshotName(id);
        var snapshot = suite[id];
        if (groups[name]) {
          groups[name].snapshots.push(snapshot);
        } else {
          groups[name] = { snapshots: [snapshot] };
        }
      });
      Object.keys(groups).forEach(function (name) {
        var snapshots = groups[name].snapshots;

        if (snapshots.length === 1) {
          var id = snapshots[0].id;

          contents.push(_react2.default.createElement(_sidebarItem2.default, {
            key: id,
            id: id,
            label: snapshotName(id),
            link: '/suite/' + _escape(fetchedItemPath) + '?id=' + _escape(id),
            icon: 'camera',
            fSelected: query && query.id === id
          }));
        } else {
          var items = snapshots.map(function (_ref2) {
            var id = _ref2.id;
            return _react2.default.createElement(_sidebarItem2.default, {
              key: id,
              id: id,
              label: id.slice(name.length).trim(),
              link: '/suite/' + _escape(fetchedItemPath) + '?id=' + _escape(id),
              icon: 'camera',
              fSelected: query && query.id === id
            });
          });
          contents.push(_react2.default.createElement(
            _sidebarItem.SidebarGroup,
            { key: name, name: name },
            items
          ));
        }
      });
      var linkBack = '/folder/' + suite.__folderPath;
      return { contents: contents, linkBack: linkBack };
    }
  }, {
    key: 'renderPreview',
    value: function renderPreview() {
      var query = this.props.query;
      var _props = this.props,
          fetchedItemType = _props.fetchedItemType,
          fetchedItemPath = _props.fetchedItemPath;

      var snapshot = void 0;
      var key = 'preview';
      if (fetchedItemType === 'SUITE' && query && query.id != null && fetchedItemPath) {
        var suite = this.props.fetchedItem;
        snapshot = suite[query.id];
        key = fetchedItemPath + '_' + query.id;
      }
      return _react2.default.createElement(_preview2.default, {
        key: key,
        snapshot: snapshot,
        fRaw: this.state.fRaw
      });
    }

    // ------------------------------------------

  }]);

  return AppContents;
}(_react2.default.PureComponent);

// ------------------------------------------


var style = {
  outer: (0, _giu.flexContainer)('row', {
    minHeight: '100vh'
  }),
  titleBarIcon: {
    cursor: 'default'
  }
};

// ==========================================
// Public API
// ==========================================
exports.default = AppContents;