'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouter = require('react-router');

var _giu = require('giu');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// ==========================================
// Component
// ==========================================


// ==========================================
// Component declarations
// ==========================================
var Sidebar = function Sidebar(_ref) {
  var title = _ref.title,
      subtitle = _ref.subtitle,
      linkBack = _ref.linkBack,
      children = _ref.children,
      fRaw = _ref.fRaw,
      toggleRaw = _ref.toggleRaw;
  return _react2.default.createElement(
    'div',
    { style: style.outer },
    _react2.default.createElement(
      'div',
      { style: style.titleBar },
      _react2.default.createElement(
        'div',
        { style: (0, _giu.flexItem)('0 0 30px') },
        _react2.default.createElement(
          _reactRouter.Link,
          {
            to: linkBack || '#',
            style: style.back
          },
          _react2.default.createElement(_giu.Icon, { icon: 'chevron-left', size: 'lg', disabled: linkBack == null })
        )
      ),
      _react2.default.createElement(
        'div',
        { style: style.title, title: subtitle },
        title
      ),
      _react2.default.createElement(
        'div',
        { style: (0, _giu.flexItem)('0 1 30px') },
        _react2.default.createElement(_giu.Icon, {
          icon: 'file-code-o',
          size: 'lg',
          onClick: toggleRaw,
          style: style.raw(fRaw),
          title: 'Toggle raw/HTML snapshot'
        })
      )
    ),
    children
  );
};

// ------------------------------------------


var style = {
  outer: (0, _giu.flexItem)('0 0 18em', {
    padding: '0.3em 0',
    backgroundColor: '#eee',
    fontFamily: 'sans-serif',
    fontSize: '0.8em',
    overflow: 'auto',
    borderRight: '2px solid #ddd'
  }),
  back: {
    margin: '0.3em',
    padding: '0.3em',
    color: 'currentColor'
  },
  titleBar: (0, _giu.flexContainer)('row', {
    alignItems: 'baseline',
    marginTop: '0.4em',
    marginBottom: '1.1em'
  }),
  title: (0, _giu.flexItem)(1, {
    textAlign: 'center',
    fontWeight: 'bold'
  }),
  raw: function raw(fRaw) {
    return {
      color: fRaw ? 'black' : 'gray'
    };
  }
};

// ==========================================
// Public API
// ==========================================
exports.default = Sidebar;