'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SidebarGroup = exports._SidebarItem = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouter = require('react-router');

var _giu = require('giu');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// ==========================================
// Component
// ==========================================


// ==========================================
// Component declarations
// ==========================================
var SidebarItem = function SidebarItem(_ref) {
  var id = _ref.id,
      label = _ref.label,
      icon = _ref.icon,
      link = _ref.link,
      fSelected = _ref.fSelected,
      hovering = _ref.hovering,
      onHoverStart = _ref.onHoverStart,
      onHoverStop = _ref.onHoverStop;

  var fHovered = hovering === id;
  return _react2.default.createElement(
    _reactRouter.Link,
    {
      id: id,
      to: link,
      style: style.outer({ fSelected: fSelected, fHovered: fHovered }),
      onMouseEnter: onHoverStart,
      onMouseLeave: onHoverStop
    },
    _react2.default.createElement(
      'div',
      { style: (0, _giu.flexItem)('0 0 20px') },
      _react2.default.createElement(_giu.Icon, { icon: icon })
    ),
    _react2.default.createElement(
      'div',
      { style: (0, _giu.flexItem)(1) },
      label
    )
  );
};

var SidebarGroup = function SidebarGroup(_ref2) {
  var name = _ref2.name,
      children = _ref2.children;
  return _react2.default.createElement(
    'div',
    { style: style.group },
    _react2.default.createElement(
      'div',
      { style: style.groupTitle },
      name
    ),
    children
  );
};

// ------------------------------------------
var style = {
  outer: function outer(_ref3) {
    var fSelected = _ref3.fSelected,
        fHovered = _ref3.fHovered;

    var backgroundColor = void 0;
    if (fSelected && fHovered) {
      backgroundColor = '#ba360a';
    } else if (fHovered) {
      backgroundColor = '#ddd';
    } else if (fSelected) {
      backgroundColor = '#ca461a';
    }
    return (0, _giu.flexContainer)('row', {
      padding: '0.3em 1em',
      cursor: 'pointer',
      color: fSelected ? 'white' : 'currentColor',
      backgroundColor: backgroundColor,
      wordBreak: 'break-word',
      alignItems: 'center',
      textDecoration: 'none'
    });
  },
  group: {
    margin: '0.5em 0',
    padding: '0.3em 0',
    backgroundColor: 'white'
  },
  groupTitle: {
    color: '#999',
    padding: '0.3em 1em',
    fontSize: '0.8em',
    textTransform: 'uppercase'
  }
};

// ==========================================
// Public API
// ==========================================
exports.default = (0, _giu.hoverable)(SidebarItem);
exports._SidebarItem = SidebarItem;
exports.SidebarGroup = SidebarGroup;