'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactFrameComponent = require('react-frame-component');

var _reactFrameComponent2 = _interopRequireDefault(_reactFrameComponent);

var _giu = require('giu');

var _largeMessage = require('./200-largeMessage');

var _largeMessage2 = _interopRequireDefault(_largeMessage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// ==========================================
// Component
// ==========================================


// ==========================================
// Component declarations
// ==========================================
var Preview = function Preview(_ref) {
  var snapshot = _ref.snapshot,
      fRaw = _ref.fRaw;

  if (!snapshot) {
    return _react2.default.createElement(
      'div',
      { style: style.outer },
      _react2.default.createElement(
        _largeMessage2.default,
        null,
        'No snapshot selected'
      )
    );
  }
  if (fRaw || !snapshot.html) {
    return _react2.default.createElement(
      'div',
      { style: style.outer },
      _react2.default.createElement(
        'pre',
        { style: style.outerNonHtml },
        snapshot.snap
      )
    );
  }
  var css = (snapshot.css || []).join('\n');
  var contents = { __html: snapshot.html };
  /* eslint-disable react/no-danger */
  return _react2.default.createElement(
    _reactFrameComponent2.default,
    {
      style: style.frame
    },
    _react2.default.createElement(
      'style',
      null,
      css
    ),
    _react2.default.createElement('div', { dangerouslySetInnerHTML: contents })
  );
  /* eslint-enable react/no-danger */
};

// ------------------------------------------
var style = {
  outer: (0, _giu.flexItem)(1, {
    transform: 'translateZ(0)' }),
  outerNonHtml: {
    margin: 0,
    padding: '0 1em'
  },
  frame: {
    border: 'none',
    width: '100%'
  }
};

// ==========================================
// Public API
// ==========================================
exports.default = Preview;